// Copyright 2023 schukai GmbH
// SPDX-License-Identifier: AGPL-3.0

package pathfinder

import (
	"fmt"
	"github.com/stretchr/testify/assert"
	"testing"
)

type Issue2SubSubStruct struct {
	Issue2SubSubField []string
}

type Issue2SubStruct struct {
	Issue2SubField Issue2SubSubStruct
}

type Issue2Struct struct {
	Issue1Sub1 Issue2SubStruct
}

func TestGetValueWithArray(t *testing.T) {
	invalidValue := Issue2Struct{
		Issue1Sub1: Issue2SubStruct{
			Issue2SubField: Issue2SubSubStruct{
				Issue2SubSubField: []string{"test0", "test1", "test2"},
			},
		},
	}

	// iterate from 0 to 2
	for i := 0; i < 2; i++ {
		result, err := GetValue(invalidValue, "Issue1Sub1.Issue2SubField.Issue2SubSubField."+fmt.Sprintf("%d", i))

		assert.Nil(t, err)
		assert.Equal(t, result, "test"+fmt.Sprintf("%d", i))
	}

	i := 3
	result, err := GetValue(invalidValue, "Issue1Sub1.Issue2SubField.Issue2SubSubField."+fmt.Sprintf("%d", i))

	assert.NotNil(t, err)
	assert.Nil(t, result)

}
